Index: oln/core/3d/point3d.hh
===================================================================
--- oln/core/3d/point3d.hh	(revision 130)
+++ oln/core/3d/point3d.hh	(working copy)
@@ -28,28 +28,24 @@
 #ifndef OLENA_CORE_3D_POINT3D_HH
 # define OLENA_CORE_3D_POINT3D_HH
 
-# include <ostream>
+# include <iostream>
 
 # include <oln/core/abstract/point.hh>
 # include <oln/core/coord.hh>
 
 namespace oln {
 
-
+  // fwd decls
   struct point3d;
   struct dpoint3d;
 
-  // category
-  template <>
-  struct set_category< point3d > { typedef category::point ret; };
-
   // super_type
   template <>
   struct set_super_type< point3d > { typedef abstract::point< point3d > ret; };
 
   // props
   template <>
-  struct set_props < category::point, point3d > : public props_of<category::point>
+  struct set_props < category::point, point3d >
   {
     typedef dpoint3d dpoint_type;
   };
Index: oln/core/gen/image_with_nbh.hh
===================================================================
--- oln/core/gen/image_with_nbh.hh	(revision 130)
+++ oln/core/gen/image_with_nbh.hh	(working copy)
@@ -29,78 +29,61 @@
 # define OLENA_CORE_GEN_IMAGE_WITH_NBH_HH
 
 # include <oln/core/abstract/image_with_extension.hh>
-# include <oln/core/abstract/image.hh>
 # include <oln/core/abstract/neighborhood.hh>
-# include <oln/core/properties.hh>
 
 namespace oln {
 
-  // fwd decls
+  // fwd decl
+  template <typename I, typename N> struct image_with_nbh;
 
-  namespace internal {
-    template <typename I, typename N> struct image_with_nbh;
-  }
-
-  // category
-
-  template <typename I, typename N>
-  struct set_category< internal::image_with_nbh<I, N> > {
-    typedef category::image ret;
-  };
-
   // super type
-
   template <typename I, typename N>
-  struct set_super_type < internal::image_with_nbh<I, N> >
+  struct set_super_type < image_with_nbh<I, N> >
   {
-    typedef abstract::image_with_extension_ < I, internal::image_with_nbh<I, N> > ret;
+    typedef abstract::image_with_extension< I, image_with_nbh<I, N> > ret;
   };
 
   template <typename I, typename N>
-  struct set_props < category::image, internal::image_with_nbh<I, N> > : public props_of<category::image>
+  struct set_props < category::image, image_with_nbh<I, N> >
   {
     typedef is_a<abstract::image_with_nbh> image_neighbness_type;
     typedef N neighb_type;
   };
 
-  namespace internal
+  template <typename I, typename N>
+  struct image_with_nbh : public abstract::image_with_extension < I, image_with_nbh<I, N> >
   {
+    typedef image_with_nbh<I, N> self_type;
+    typedef abstract::image_with_extension < I, self_type > super_type;
 
-    template <typename I, typename N>
-    struct image_with_nbh : public oln::abstract::image_with_extension_ < I, image_with_nbh<I, N> >
+  public:
+
+    image_with_nbh(const abstract::image<I>& image,
+		   const abstract::neighborhood<N>& nbh) :
+      super_type(image),
+      nbh_(nbh.exact())
     {
-      typedef image_with_nbh<I, N> self_type;
-      typedef oln::abstract::image_with_extension_ < I, self_type > super_type;
+    }
 
-    public:
+    const N& impl_nbh_get() const
+    {
+      return nbh_;
+    }
 
-      image_with_nbh(abstract::image<I>& rhs,
-		     abstract::neighborhood<N>& nbh) :
-	super_type(rhs), nbh_(nbh.exact())
-      {
-      }
+  protected:
 
-      const N& impl_nbh_get() const
-      {
-	return nbh_;
-      }
+    N& nbh_;
+  };
 
-    protected:
-      N& nbh_;
-    };
 
-  } // end of namespace oln::internal
-
-
-
   /// the 'image_with_nbh' method for images
 
   template <typename I, typename N>
-  internal::image_with_nbh<I, N>
-  join(abstract::image<I>& ima,
-       abstract::neighborhood<N>& nbh)
+  image_with_nbh<I, N>
+  join(const abstract::image<I>& image,
+       const abstract::neighborhood<N>& nbh)
   {
-    internal::image_with_nbh<I, N> tmp(ima, nbh);
+    image_with_nbh<I, N> tmp(image, nbh);
     return tmp;
   }
 
Index: oln/basics.hh
===================================================================
--- oln/basics.hh	(revision 130)
+++ oln/basics.hh	(working copy)
@@ -50,7 +50,6 @@
 // oln::
 
 # include <oln/core/coord.hh>
-# include <oln/core/properties.hh>
 # include <oln/core/value_box.hh>
 # include <oln/core/box.hh>
 
@@ -63,14 +62,13 @@
 
 # include <oln/core/pw/all.hh>
 
-# include <oln/core/abstract/piter.hh>
-# include <oln/core/abstract/witer.hh>
-// # include <oln/core/abstract/niter.hh>
 
-# include <oln/core/abstract/struct_elt.hh>
+# include <oln/core/abstract/window.hh>
 # include <oln/core/abstract/neighborhood.hh>
 
+# include <oln/core/abstract/piter.hh>
+# include <oln/core/abstract/qiter.hh>
+# include <oln/core/abstract/niter.hh>
 
 
-
 #endif // ! OLENA_BASICS_HH
Index: oln/morpho/reconstruction.hh
===================================================================
--- oln/morpho/reconstruction.hh	(revision 130)
+++ oln/morpho/reconstruction.hh	(working copy)
@@ -37,7 +37,6 @@
 
 # include <oln/core/abstract/image_operator.hh>
 # include <oln/core/abstract/neighborhood.hh>
-# include <oln/core/properties.hh>
 
 # include <oln/level/compare.hh>
 
@@ -267,7 +266,7 @@
 	  bool exist_init()
 	  {
 	    typedef oln_type_of(N, window) se_type;
-	    oln_type_of(se_type, fwd_witer) dp(se_minus);
+	    oln_type_of(se_type, fwd_qiter) dp(se_minus);
 	    for_all (dp)
 	      {
 		q = (oln_type_of(se_type, dpoint))dp +
@@ -324,7 +323,7 @@
 		fifo.pop();
 		typedef oln_type_of(N, window) window_type;
 		window_type w = convert::nbh_to_se(this->nbh);
-		oln_type_of(window_type, fwd_witer) dp(w);
+		oln_type_of(window_type, fwd_qiter) dp(w);
 
 		for_all (dp)
 		  {
Index: oln/morpho/splitse.hh
===================================================================
--- oln/morpho/splitse.hh	(revision 130)
+++ oln/morpho/splitse.hh	(working copy)
@@ -78,7 +78,7 @@
     E
     get_plus_se_only(const abstract::struct_elt<E>& se)
     {
-      oln_type_of(E, fwd_witer) dp(se.exact());
+      oln_type_of(E, fwd_qiter) dp(se.exact());
       E out;
 
       for_all (dp)
@@ -112,7 +112,7 @@
     E
     get_plus_se_p(const abstract::struct_elt<E>& se)
     {
-      oln_type_of(E, fwd_witer) dp(se.exact());
+      oln_type_of(E, fwd_qiter) dp(se.exact());
       E out;
 
       for_all (dp)
@@ -148,7 +148,7 @@
     E
     get_minus_se_only(const abstract::struct_elt<E>& se)
     {
-      oln_type_of(E, fwd_witer) dp(se.exact());
+      oln_type_of(E, fwd_qiter) dp(se.exact());
       E out;
 
       for_all (dp)
@@ -182,7 +182,7 @@
     E
     get_minus_se_p(const abstract::struct_elt<E>& se)
     {
-      oln_type_of(E, fwd_witer) dp(se.exact());
+      oln_type_of(E, fwd_qiter) dp(se.exact());
       E out;
 
       for_all (dp)
Index: oln/morpho/stat.hh
===================================================================
--- oln/morpho/stat.hh	(revision 130)
+++ oln/morpho/stat.hh	(working copy)
@@ -68,7 +68,7 @@
           // FIXME: test dim I == dim
 	  mlc::eq<oln_type_of(I, size), oln_type_of(E, size)>::ensure();
 
-          oln_type_of(E, fwd_witer) dp(se);
+          oln_type_of(E, fwd_qiter) dp(se);
 	  dp.start();
 	  V val = input[p + dp];
           for_all_remaining (dp)
@@ -94,7 +94,7 @@
           // FIXME: test dim I == dim E
 	  mlc::eq<oln_type_of(I, size), oln_type_of(E, size)>::ensure();
 
-	  oln_type_of(E, fwd_witer) dp(se);
+	  oln_type_of(E, fwd_qiter) dp(se);
 	  dp.start();
 	  V val = input[p + dp];
 	  for_all_remaining (dp)
@@ -115,7 +115,7 @@
 	max(const I& input, const oln_type_of(I, point)& p, const E& se)
 	{
 	  mlc::eq<oln_type_of(I, size), oln_type_of(E, size)>::ensure();
-	  oln_type_of(E, fwd_witer) dp(se);
+	  oln_type_of(E, fwd_qiter) dp(se);
 	  for_all (dp)
 	    if (input.hold(p + dp))
 	      if (input[p + dp] == true)
@@ -127,7 +127,7 @@
 	min(const I& input, const oln_type_of(I, point)& p, const E& se)
 	{
 	  mlc::eq<oln_type_of(I, size), oln_type_of(E, size)>::ensure();
-	  oln_type_of(E, fwd_witer) dp(se);
+	  oln_type_of(E, fwd_qiter) dp(se);
 	  for_all (dp)
 	    if (input.hold(p + dp))
 	      if (input[p + dp] == false)
Index: oln/arith/ops.hh
===================================================================
--- oln/arith/ops.hh	(revision 130)
+++ oln/arith/ops.hh	(working copy)
@@ -60,7 +60,7 @@
 /// Operator - (unary) on image.
 
 template <typename R>
-oln::image_from_pw< oln::pw::minus< oln::pw::literal< oln_pw_value_type(R) >,
+oln::image_from_pw< oln::pw::minus< oln::pw::literal< oln_pw_type_of(R, value) >,
 				    oln::pw::image<R> > >
 operator - (const oln::abstract::image<R>& rhs)
 {
Index: oln/arith/min.hh
===================================================================
--- oln/arith/min.hh	(revision 130)
+++ oln/arith/min.hh	(working copy)
@@ -43,13 +43,6 @@
 
   }
 
-  // category
-  template <typename I>
-  struct set_category< arith::impl::min_type<I> >
-  {
-    typedef category::image ret;
-  };
-
   // super_type
   template <typename I>
   struct set_super_type< arith::impl::min_type<I> >
Index: oln/arith/max.hh
===================================================================
--- oln/arith/max.hh	(revision 130)
+++ oln/arith/max.hh	(working copy)
@@ -43,13 +43,6 @@
 
   }
 
-  // category
-  template <typename I>
-  struct set_category< arith::impl::max_type<I> >
-  {
-    typedef category::image ret;
-  };
-
   // super_type
   template <typename I>
   struct set_super_type< arith::impl::max_type<I> >
Index: oln/io/read_image.hh
===================================================================
--- oln/io/read_image.hh	(revision 130)
+++ oln/io/read_image.hh	(working copy)
@@ -35,7 +35,6 @@
 
 # include <ntg/core/macros.hh>
 
-# include <oln/core/properties.hh>
 # include <oln/io/read_image_2d_pnm.hh>
 # include <oln/io/utils.hh>
 # include <oln/io/gz_stream.hh>
